/* gInfo - Copyright (C) 2004 bakunin - Andrea Marchesini 
 *                                      <bakunin@autistici.org>
 *
 * This source code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Public License as published 
 * by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * This source code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * Please refer to the GNU Public License for more details.
 *
 * You should have received a copy of the GNU Public License along with
 * this source code; if not, write to:
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * This program is released under the GPL with the additional exemption that
 * compiling, linking, and/or using OpenSSL is allowed.
 */

#ifndef GINFO_PLUGIN_H
#define GINFO_PLUGIN_H

#include <gtk/gtk.h>

#define GINFO_GENRE_SOFTWARE	1
#define GINFO_GENRE_SYSTEM	2
#define GINFO_GENRE_CODE	4
#define GINFO_GENRE_NETWORK	8

#define GINFO_SUBGENRE_SYSTEM	16
#define GINFO_SUBGENRE_NETWORK	32
#define GINFO_SUBGENRE_AUDIO	64
#define GINFO_SUBGENRE_VIDEO	128
#define GINFO_SUBGENRE_STREAM	256
#define GINFO_SUBGENRE_OFFICE	512

typedef struct
{
  char *text;
  GtkWidget *(*func) (void);

} ginfo_tips;

typedef struct
{
  char *text;
  GtkWidget *(*func) (void);

} ginfo_docs;

/* MODULE FUNCTIONS: */
int module_default(void);
char *module_name (void);
int module_genre (void);
char **module_words (void);
ginfo_tips *module_tooltips (int *);
ginfo_docs *module_docs (int *);

/* UTIL FUNCTIONS: */
void ginfo_error (char *);
GtkWidget *ginfo_window(void);

/* EASY FUNCTIONS: */
void *ginfo_easy_docs_init(void);
int  ginfo_easy_docs_add(void *, char *, GtkWidget *(*)(void));
ginfo_docs * ginfo_easy_docs_close(void *, int *);

void *ginfo_easy_tips_init(void);
int  ginfo_easy_tips_add(void *, char *, GtkWidget *(*)(void));
ginfo_tips * ginfo_easy_tips_close(void *, int *);

#endif
